#! /usr/local/bin/perl

package Drs;
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(
	     drs_Login 
	     drs_Logoff 
	     drs_Les 
	     drs_Rapporter 
	     drs_Flett 
	     drs_NyttFelt
	     drs_SlettFelter
	     drs_SortPost);

use ARS;

$MAKS_POSTER = 1000000;

# ------------------------------------------------------------
#
# Rutine for  foreta en ars_Login, ved  hente 
# brukernavn og passord fra fil 
#
# ------------------------------------------------------------

sub drs_Login {

    # Lokale variabler

    my ($path,$kontroll);
    my ($brukernavn,$passord,$kodet_passord);
    my ($vertsmaskin) = @_;    
    
    $fil = "drslogin";
    $path = "$ENV{\"HOME\"}/.drslogin/";

    if(open(LOGIN, $path . $fil) || open(LOGIN, $fil)) {
	
	# Leser inn brukernavn og passord fra fil
	
	(chop($brukernavn = <LOGIN>)) ||
	    die "Feil i $path, kan ikke lese brukernavn\n";
	(chop($kodet_passord = <LOGIN>)) ||
	    die "Feil i $path, kan ikke lese passord\n";
	$passord = unpack("u",$kodet_passord);
	close(LOGIN);
	
    } else {
	($brukernavn,$passord) = drs_Skriv_Passord($path,$fil);
    }

    # Arsperl funksjon for  logge inn p nsket vertsmaskin

    ($kontroll = ars_Login($vertsmaskin,$brukernavn,$passord)) || 
	die "Feil i login : $ars_errstr!\n";
    
    return $kontroll;
}

# ------------------------------------------------------------
#
# Rutine for  lagre nytt passord i stende katalog eller
# i hjemmekatalogen (dvs. ~/.drslogin).
# Passordfilen som blir opprettet heter drslogin. 
#
# ------------------------------------------------------------

sub drs_Skriv_Passord {

    my($navn,$passord,$valg,$kodet_passord);
    my($path,$fil) = @_;

    # Oppretter katalog .drslogin dersom den ikke eksisterer,
    # og gjr den kun leselig for eier

    (-e $path) or mkdir $path, 0700;
    if (!(-d $path and -r $path and -x $path))  {
	$drs_error = "$path: ikke lesbar katalog";
	die $drs_error;
    }
    
    print STDERR "DRS login navn: ";
    chop($navn = <STDIN>);  
   
    # Slr av ekko nr passord skal tastes inn

    print STDERR "DRS login passord: ";
    system("stty -echo");
    chop($passord = <STDIN>);
    system("stty echo");
     
    print STDERR "\nLagre passord i (d)enne katalogen, eller i (h)jemmekatalogen: ";
    chop($valg = <STDIN>);
    until (($valg eq "d" )||($valg eq "h")) {
	chop($valg = <STDIN>);
    }

    if($valg eq "h") {
	open (LOGIN,">" . $path . $fil) ||
	    die "Fikk ikke pne $path . $fil\n";
    } else {
	open (LOGIN,">" . $fil) ||
	    die "Fikk ikke pne $fil\n";
    }

    $kodet_passord = pack("u",$passord); 
    print LOGIN "$navn\n$kodet_passord\n";
    close LOGIN;

    return ($navn,$passord);
}

# ------------------------------------------------------------
#
# Rutine som benytter ars_Logoff for  logge seg ut
# av databasen 
#
# ------------------------------------------------------------

sub drs_Logoff {

    # Lokal variabel, initialisert med innparameter

    my($kontroll) = @_;

    # Arsperlfunksjon for  logge seg ut av databasen

    ars_Logoff($kontroll);
}

# ------------------------------------------------------------
#
# Benytter arsPerl moduler til  gjre oppslag i drs-databasen
#
# ------------------------------------------------------------

sub drs_Les {
 
    # Lokale variabler

    my ($kvalifisert,$feltpeker,$post_id,$felt,$verdi,$nr,$alle);
    my (%poster,%felter_id,%skjema,%felt_info); 
    my (@alle_felter,@felter,@felt_id);
    my ($kontroll,$valg,$skjema,$navn,$meldinger) = @_;
    my ($kontroll,$valg,$skjema,$navn,$meldinger,@felter) = @_;
    
    # Arsperl funksjoner

    ($kvalifisert = ars_LoadQualifier($kontroll,$skjema,$valg)) ||
	die "Skjema, seleksjon eller passord er feil  : $ars_errstr!\n";
   
    (%poster = ars_GetListEntry($kontroll,$skjema,$kvalifisert,0)) ||
	die "Seleksjon er feil  : $ars_errstr!\n";
    
    (%felter_id = ars_GetFieldTable($kontroll,$skjema)) ||
	    die "Skjema er feil  : $ars_errstr!\n";
    
    $alle = 0;
  
    if(!(defined(@felter))) {
	$alle = 1;
    }

    if(!(defined(@felter))) {
	@alle_felter = keys(%felter_id);
	foreach $felt (@alle_felter) {
	    if($felt =~ /[A-Za-z\-_ ]+/) {
		push(@felter,$felt);
	    }
	}
    }
    
    $nr = $MAKS_POSTER;
 
    foreach $felt (@felter) {
	push(@felt_id,ars_GetFieldByName($kontroll,$skjema,$felt));
	($felt_info{$felt} = ars_GetField($kontroll,$skjema,$felter_id{$felt})) ||
	    die $ars_errstr;
    }
   
    foreach $post_id (keys %poster) {
	if($alle == 1) {
	    (%verdier = ars_GetEntry($kontroll,$skjema,$post_id)) ||
		die "Feil i feltnavn : $ars_errstr\n";
	} else {
	    (%verdier = ars_GetEntry($kontroll,$skjema,$post_id,@felt_id)) ||
		die "Feil i feltnavn : $ars_errstr\n";
	}
	if(defined($meldinger)) {
	    print STDERR "$nr\b\b\b\b\b\b\b";
	}
	foreach $felt (@felter) {
	    $verdi = $verdier{$felter_id{$felt}}; 
	    $verdi = drs_SjekkDataType($felt_info{$felt},$verdi,$felt);
	    if($navn eq "dummy") {
		$skjema{"post".$nr}{$felt} = $verdi;
	    } else {
		$skjema{"post".$nr}{$navn.".".$felt} = $verdi;
	    }
	}   
	$nr++;
    }
    undef(@felter);
    return %skjema;
}

# ------------------------------------------------------------
#
# Skriver ut alle poster, felter med tilhrende verdier til  
# STDOUT 
#
# ------------------------------------------------------------

sub drs_Rapporter {
    
    # Lokale variabler
    
    my ($felt,$post);
    my (@felter);
    my (%skjema);
    my ($ref_skjema,$felter) = @_;

    %skjema = %{$ref_skjema}; 
    
    foreach $post (sort keys %skjema) {
	if(defined(@$felter)) {
	    foreach $felt (@$felter) {
		$verdi = $skjema{$post}{$felt};
		
		# Fjerner starten p alle felter som starter med
		# navn.felt, dvs. felter med like navn
		
		$felt_ut = $felt;
		$felt_ut =~ s/[\w]+\.//;
		print STDOUT "$felt_ut : $verdi\n"; 
	    }
	} else {
	   
	    foreach $felt (sort (keys %{$skjema{$post}})) {
		$verdi = $skjema{$post}{$felt};
		$felt =~ s/[\w]+\.//;
		print STDOUT "$felt : $verdi\n"; 
	    }
	}
	print STDOUT "\n";
    }
}


# ------------------------------------------------------------
#
# Legger til ett nytt felt med tilhrende verdi i alle postene
# i gitt skjema 
#
# ------------------------------------------------------------

sub drs_NyttFelt {
 
    # Lokale variabler
    
    my ($post);
    my (%skjema);
    my ($felt,$verdi,$ref_skjema) = @_; 
    
    %skjema = %{$ref_skjema}; 

    # Legg til nytt felt i alle poster

    foreach $post (keys %skjema) {
	$skjema{$post}{$felt} = $verdi;
    }
    return %skjema;
}

# ------------------------------------------------------------
#
# Fjerner alle valgte felter med tilhrende 
# verdier for alle postene i et gitt skjema  
#
# ------------------------------------------------------------

sub drs_SlettFelter {
    

    # Lokale variabler
    
    my ($felt,$post);
    my (@felter);
    my (%skjema);
    my ($felter,$ref_skjema) = @_;

    %skjema = %{$ref_skjema}; 
    
    # Sletter alle valgte felter i alle postene til et gitt skjema

    foreach $post (keys %skjema) {
	foreach $felt (@$felter) {
	    delete ($skjema{$post}{$felt});
	}
    }
    return %skjema;
}

# ------------------------------------------------------------
#
# Sorterer et skjema numerisk og alfabetisk  
#
# ------------------------------------------------------------

sub drs_SortPost {

    my($post,$verdi,$nr);
    my($felt,$rekkefolge,%skjema) = @_;
    my(%sortert_skjema);

    $nr = $MAKS_POSTER;
    
    # Finner frst alle aktuelle verdier som skal sorteres

    foreach $post (sort keys %skjema) {
	push(@verdier,$skjema{$post}{$felt})
    }
    
    # Sorterer verdiene enten forlengst eller baklengst

    if($rekkefolge == 2) {
	@verdier = reverse sort (@verdier);
    } else {
	@verdier = sort (@verdier);
    }
   
    foreach $verdi (@verdier) {
	foreach $post (sort keys %skjema) {
	    if($verdi eq $skjema{$post}{$felt}) {
		$sortert_skjema{"post".$nr++} = $skjema{$post};
		delete($skjema{$post});
		last;
	    }
	}
    }
    return %sortert_skjema;
}

# ------------------------------------------------------------
#
# Fletter samme to ulike skjemaer til ett. Benytter det
# som kalles 'inner join' (eller 'natural join' eller
# 'equi-join') for  flette sammen skjemaene. Det innebrer
# at kun poster med like betingelser blir tatt vare p.
#
# ------------------------------------------------------------

sub drs_Flett {
    
    my ($nr,$like);
    my ($post1,$felt1,$verdi1);
    my ($post2,$felt2,$verdi2);
    my (%skjema1,%skjema2,%resultat);
    my ($ref1,$ref2,$bet1,$bet2)= @_; 
    
    $nr = $MAKS_POSTER;
    $like = 0;
    undef(%resultat);
    %skjema1 = %{$ref1};
    %skjema2 = %{$ref2};

    foreach $post1 (keys %skjema1) {
	foreach $post2 (keys %skjema2) {
	    $verdi1 = $skjema1{$post1}{$bet1};
	    $verdi2 = $skjema2{$post2}{$bet2};
	    if($verdi1 eq $verdi2) {
		$like++;
		foreach $felt1 (keys %{$skjema1{$post1}}) {
		    $verdi1 = $skjema1{$post1}{$felt1};
		    $resultat{"post".$nr}{$felt1} = $verdi1;
		}
		foreach $felt2 (keys %{$skjema2{$post2}}) {
		    $verdi2 = $skjema2{$post2}{$felt2};
		    $resultat{"post".$nr}{$felt2} = $verdi2;
		}
		$nr++;
	    }
	}
    }
    
    return ($like,%resultat);
}

# ------------------------------------------------------------
#
# Sjekker alle datatypenn til de enkelte datafeltene 
# som leses fra databasen, og endrer verdier dersom det 
# er ndvendig
#
# ------------------------------------------------------------

sub drs_SjekkDataType {
    
    # Innparametre gjort til lokale variabler

    my ($felt_info,$verdi,$felt) = @_;
       
    # Sjekker de ulike datatypene, og gjr evt. endringer

  SWITCH: {
      if ($felt_info->{dataType} eq "bitmask") { 
	  return $verdi; 
	  last SWITCH; }
      if ($felt_info->{dataType} eq "null") { 
	  return $verdi; 
	  last SWITCH; }
      if ($felt_info->{dataType} eq "char") { 
	  return $verdi; 
	  last SWITCH; }
      if ($felt_info->{dataType} eq "control") { 
	  return $verdi; 
	  last SWITCH; }
      if ($felt_info->{dataType} eq "diary") { 
	  return $verdi; 
	  last SWITCH; }
      if ($felt_info->{dataType} eq "enum") { 
	  $verdi = $felt_info->{limit}[$verdi];
	  return $verdi; 
	  last SWITCH; }
      if ($felt_info->{dataType} eq "integer") { 
	  return $verdi; 
	  last SWITCH; }
      if ($felt_info->{dataType} eq "keyword") { 
	  return $verdi; 
	  last SWITCH; }
      if ($felt_info->{dataType} eq "real") { 
	  return $verdi; 
	  last SWITCH; }
      if ($felt_info->{dataType} eq "time") { 
	  if($verdi > 0) {
	      ($sek,$min,$time,$dagmaa,$maa,$aar,$ukedag,$aardag,$flagg) = 
		  localtime($verdi);
	      $maa++;
	      $verdi = "$dagmaa/$maa/$aar";
	  }
	  return $verdi; 
	  last SWITCH; }
      print STDERR "$felt har en ukjent datatype: $felt_info->{dataType}\n";
  }
}





