#!/usr/bin/perl
push(@INC,"/kart/lib/perl");
require "kart-lib.pl";
require "newgetopt.pl";
require "utm.pl";

$kartliste_hs="/kart/drs/hs.omriss ";

$ekstra_map = 20; # ekstra punkter for map til byer
$ekstra_storleik = 200000000; # Oslo er 120M
$PKT_STORRELSE = 8;

$usage="Lager et brukerside bildekart. Bruk:

  kartmap -kart <fil> -koord <fil> -gif <gif-url> [-ref <html ref>]
      [-bredde <min bredde p linjene>] [-tittel <tekst>] [-last]
      [-ikke <objektklasse>] [-omriss <fil>] [-areameny] [-friskopp <sekunder>]
      [-java <program> [-javabase <programkatalog>] [<URLfil>] 
  -imagemap - legg ut bare imagemap og ikke annen html
  -net <network id> - name of network
  -kart  - grunnlagskart (.ps)
  -gif   - url for gif-hkart
  -ref   - sub-katalog for kartene av samme type(last)
  -href - liste over href for referanse i html
  -ikke  - angir en punkt- eller linje-type som ikke skal tegnes
  -omriss - liste over kart som det skal zoomes til
  -last  - angir at linjebredde hentes fra koordinatfila
  -friskopp - antall sekunder for oppfriskning av doument (refresh)
  -java  - lag Java HTML-kode
  -javabase - url for Java-katalog
  -javacode - Java-programnavn
  -areameny - Lage menyer for zooming
";

die $usage if !&NGetOpt( 'net=s', 'kart=s', 'koord=s', 'gif=s', 'bredde=s', 'tittel=s', 'ikke=s', 'imagemap', 'href=s', 'ref=s', 'omriss=s', 'java', 'javabase=s', 'javacode=s', 'last', 'areameny', 'friskopp=s');

die "Flere parametre \n" . $usage if !( $opt_kart && $opt_koord && $opt_gif);
$opt_bredde=8 unless ($opt_bredde) ;

$opt_tittel="UNINETT kart" unless $opt_tittel;
$net=$opt_net || "uninett";
$hovedkart="/kart/$net/conf/geo.omriss";

$gif_fila=$opt_gif;
$ps_fila=$opt_kart;
$opt_ref = $opt_ref || "last" ;
$kartliste= $opt_omriss || $hovedkart;
$opt_javabase= $opt_javabase || "/kart/java";
$opt_javacode= $opt_javacode || "Imagemap.class";

$kartet = $opt_kart;
$kartet =~ s/.*\///;
$kartet =~ s/.ps$//;
$kartet =~ s/^.*\.//;  # ##### OBS - fjerner alle ledd foran punktum


print "<!-- \n"; 
print "Bruker: $ps_fila, $gif_fila og $opt_koord *********** \n";

# pne konfigurasjonsfil.
die "Feil: kunne ikke pne $ps_fila !\n $usage" if -z $ps_fila || !open(PS, $ps_fila);
$i=0;
# Les PS-filen for  finne ut st-nord-koordinatene og strrelsen p den
# resulterende gif-bildet.

while($innlinje=<PS>) {
    $i++;
    chop($innlinje);
    if ($innlinje =~ /^%Area:/) {
        $_=$innlinje;
        s/%Area:\s*//;
        @grunn_koords=split(/,/,$_); #st-nord Koordinatene til kartet 
        print "Grunn-koordinater: $grunn_koords[0], $grunn_koords[1], $grunn_koords[2], $grunn_koords[3]\n";
        $area=1;
    }
    if ($innlinje =~ /^%Skalering:/) {
        #skalerings faktoren fra ps til gif kartet
        ($tmp,$skalering)=split(/:\s+/,$innlinje); 
        #print "$innlinje \n";
        print "Skaleringa er: $skalering \n";
    }

    if ($innlinje =~ /^%Giftrans:/) {
        ($tmp,$giftrans)=split(/:\s+/,$innlinje); 
        #print "$innlinje \n";
        print "Giftrans er: $giftrans \n";
    }
    if ($innlinje =~ /^%Sone:/) {
        ($tmp,$grunn_sone)=split(/:\s+/,$innlinje); 
        #print "$innlinje \n";
        print "Grunn-sonen er: $grunn_sone \n";
    }
    if ($innlinje =~ /^%Size:/){
        $_=$innlinje;
        s/%Size://;
	@gif_size=split; #gif dimensjoner til kartet 
        #print "$innlinje \n";
        print "Bredde : $gif_size[0], Hyde: $gif_size[1] \n";
        $size=1;
    }
    if ($area && $size && $skalering && $giftrans && $grunn_sone) {last;}
}
print "[$i linjer lest inn]\n";
close (PS);


# lesser in kartlister

open(LISTE, "<$kartliste") || die "Fant ikke $kartliste\n";

while(<LISTE>){
    next if /^#/;
    ($kartnavn, $sosi, $format, $velg, $layout, $pri, $sone, $n1, $o1, $n2, $o2, $stor, $niv, $rand, $beskr, $rest)
	=split(/\s*\,\s*/);

    ($n1, $o1) = utmtoutm($n1, $o1, $sone, $grunn_sone) 
	if $sone != $grunn_sone;
    ($n2, $o2) = utmtoutm($n2, $o2, $sone, $grunn_sone) 
	if $sone != $grunn_sone;

    push(@kartene, $kartnavn);
    $storleik{$kartnavn}= abs($n2 - $n1) * abs($o2 - $o1);
    $sosi{$kartnavn}=$sosi;
    $n1{$kartnavn}=$n1;
    $n2{$kartnavn}=$n2;
    $o1{$kartnavn}=$o1;
    $o2{$kartnavn}=$o2;
    $niv{$kartnavn}=$niv;

    if($sosi eq "blank"){
	$type = "topo";
    } else { 
	$type = "geo";
    }

    $href{$kartnavn}= sprintf "$opt_ref", $kartnavn;
}



# lesser inn koordinat filen n

die "Feil: kunne ikke pne $opt_koord !\n $usage" if -z $opt_koord || !open(KOORDS, $opt_koord);

while($innlinje=<KOORDS>) {
    chop($innlinje);

    #print "$innlinje \n";
    #<STDIN>;
    if ($innlinje =~ /^LINJE/) {
	($tmp,$type,$navn,$sted1,$sted2, @rest)=split(/\s+/,$innlinje);

	next if $linjer{$navn}; # dublerte linjer er tvetydig

	$ikke{$navn} =  $type eq $opt_ikke if $opt_ikke;
	$linjer{$navn}=$innlinje;

	$bredde{$navn}=$opt_bredde;
	$bredde{$navn}=$rest[0] if $opt_last && ($rest[0] > $opt_bredde);

        push(@linjer,$innlinje);
        #print "Giftrans blir : $giftrans \n";
	
    }
    if ($innlinje =~ /^PUNKT/) {
	($tmp,$type,$navn,$sone,$nord,$ost, $rest)=split(/\s+/,$innlinje,7);
	$ikke{$navn} =  $type eq $opt_ikke if $opt_ikke;
	#print " Sone konvertering : grunn: $grunn_sone - current: $sone \n";
	#print " Foer : $nord, $ost \n";

	if ($sone eq "gif"){
	    ($y{$navn}, $x{$navn})=($nord, $ost);
	} else {
	    if ($sone != $grunn_sone){
		($nord,$ost) = &utmtoutm($nord,$ost,$sone,$grunn_sone);
	    }

	#Sjekker om stedet/punktet er innenfor kartet
# det kan vre greit  la linjer g ut av kartet
#	unless ($nord < $grunn_koords[0] || $nord > $grunn_koords[2] || 
#		$ost < $grunn_koords[1] || $ost > $grunn_koords[3]) {
	    
	    $gif_x=($ost - $grunn_koords[1]) / $skalering * $giftrans;
	    $gif_y= $gif_size[1]-(($nord - $grunn_koords[0]) / 
				  $skalering * $giftrans);
	    #   print "$navn : ($nord,$ost) -> ($gif_x,$gif_y) \n";

	    $y{$navn}=$gif_y;
	    $x{$navn}=$gif_x;
#	}
	}
	push(@steder,$innlinje);
    }
    if ($innlinje =~ /^AREAL/) {
	
	($tmp,$type,$navn,$rest)=split(/\s+/,$innlinje,4);
	if ($type eq "rektangel"){
	    ($x1, $y1, $x2, $y2, $text)=split(/\s+/, $rest, 5);
	    $rect_co{$navn} = [$x1, $y1, $x2, $y2];
	    $text =~ s/^\(|\)$//g;
	    $rect_name{$navn} = $text;
	}
    }
}
close (KOORDS);

#
# preprocess lines and make coordinates for maps

$lid=0;

foreach $linje (@linjer){

    # Ekstrakt navnet p ende punktene (sted1 og sted2)
    ($tmp,$type,$navn,$sted1,$sted2, $rest)=split(/\s+/,$linje,6);

    #Hvis de stedene fins i tabellen i det heletatt.
    if ( ($x{$sted1}!=0) && ($x{$sted2}!=0)) {
	# legger map'ene $opt_bredde fra punktet

	$d=$opt_bredde / 2;
	$x1=$x{$sted1};  $x2=$x{$sted2};
	$y1=$y{$sted1};  $y2=$y{$sted2};
	$dx = $x2 - $x1;
	$dy = $y2 - $y1;
	$linjelengde=sqrt($dx**2 + $dy**2);

	next if $x1 == $x2 && $y1 == $y2; # null linje

	# flytt p parallelle samband
	# prinsipp : parallellforskyvning vinkelrett p 
	# - ref likedannede trekanter 

	$ptykk=$PKT_STORRELSE-2;  # fast verdi = kartgif
	@sortsted=sort($sted1, $sted2);
	$stedsted="$sortsted[0],$sortsted[1]";

	if ($tykk = $sambTykk{$stedsted}){ # et er tegnet allerede

	    if($linjelengde > 0){
		$dt= ($ptykk + 1 ) / 2 + $tykk;
		$ddx = int($dy * $dt / $linjelengde);
		$ddy = int($dx * $dt / $linjelengde);
		$x1 += $ddx;
		$y1 -= $ddy;
		$x2 += $ddx;
		$y2 -= $ddy;
	    }
	}
	$sambTykk{$stedsted} += $ptykk + 3 ;


	# Bruk formelen for  finne DeltaX og DeltaY brukt for  
	#finne koordinatene til polygonen rundt hver linje
	# formelen under : dX=(y1-y0)*bredde / sqrt((x1-x0)^2)+((y1-y0)^2)

	$dX=($y2-$y1)* $bredde{$navn}/2/
	    sqrt(($x2-$x1)*($x2-$x1)+
		 ($y2-$y1)*($y2-$y1));
	# formelen under : dY=(x1-x0)*bredde / sqrt((x1-x0)^2)+((y1-y0)^2)
	$dY=($x2-$x1)*$bredde{$navn}/2/
	    sqrt(($x2-$x1)*($x2-$x1)+
		 ($y2-$y1)*($y2-$y1));
	
	$koord[0]=$x1-$dX;		
	$koord[1]=$y1+$dY;	
	$koord[2]=$x1+$dX;	
	$koord[3]=$y1-$dY;	
	$koord[4]=$x2+$dX;	
	$koord[5]=$y2-$dY;
	$koord[6]=$x2-$dX;	
	$koord[7]=$y2+$dY;
	$tmp=sprintf("%d,%d,%d,%d,%d,%d,%d,%d,$navn,",
		     $koord[0],$koord[1],$koord[2],$koord[3],
		     $koord[4],$koord[5],$koord[6],$koord[7], $url);
	$linje_liste{$navn}=$tmp;

	$lnavn{$lid}=$navn;
	$llengde{$lid}=$linjelengde;
	$lid++;
    }
}

#
# emit html headers


printf "-->\n";

unless ($opt_imagemap){
    if($opt_friskopp){
	print "<meta http-equiv=Refresh content=$opt_friskopp url=http://drs.uninett.no/kartg/last/$type/$kartid/$intervall>\n";
    }

#<a href=http://www.uninett.no/statistikk><IMG  SRC=/kart/topp_teknisk_l.jpg 
#ALT=UNINETT  HEIGHT=40 WIDTH=500 ALIGN=BOTTOM BORDER=0></a>

    printf "
<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\">
<html> <head>
<title align=center>$opt_tittel</title>
<LINK REL=StyleSheet TYPE=text/css HREF=/hodebunn/uninett.css>
</head>

<BODY BGCOLOR=#FFFFFF>
<a href=http://www.uninett.no/statistikk><IMG  SRC=/hodebunn/uninett-gronn.jpg
align=right></a> 
<h2 align=center>$opt_tittel</h2>

<p>
Se ogs <a href=/kart> kartoversikt</a>";


    if($sosi{$kartet} ne "blank"){
	if($opt_java){
	    printf ", <a href=/kartg/kartreg2/$kartet>koordinatavlesing</a>";
	} else {
	    printf ", <a href=/kartg/kartreg/$kartet>koordinatavlesing</a>";
	}
    }
    printf "%s\n", sideurler($kartet) if $opt_java;
    printf ".<hr>\n";
}

#
# leser inn URL-fil
#

$lid=0; # linje-URL nr

while($innlinje=<>) {
    chop($innlinje);
    next if $innlinje =~ m/^\s*\#|^\s*$/;

    if ($innlinje =~ /^INFO/) {
	($tmp,$menyID)=split(/\s+/,$innlinje,2);
	#print ("NYYY INFOOO $menyID \n");
	#<STDIN>;

    } elsif ($innlinje =~ /^PUNKT/) {
	# Ekstrakt ut navnet p stedet og urlen
	($tmp,$navn,$url_inf)=split(/\s+/,$innlinje,3);
	($url, $meny2)=split(/[|]/, $url_inf);
	#hvis det er ment  ta med punkter i det heletatt
	if (($x{$navn}!=0 || $rect_co{$navn}) && !$ikke{$navn}) {
	    # Hvis det er frste gang vi er kommet til dette punktet her ...
	    if ($punkt_liste{$navn}){
		# Hvis den siste delen bak linja er IKKE samme 
                #  som den vi skal slenge bak p linja n
		if (! $lastpartp{$navn,$menyID,$meny2,$url}) {
		    $punkt_liste{$navn}.="|$menyID $meny2,$url";
		    $lastpartp{$navn,$menyID,$meny2,$url}=1;
		}
	    }else{                           
		$punkt_liste{$navn}=sprintf ("%d,%d,%d,$navn,|$menyID $meny2,%s",$x{$navn},$y{$navn},$opt_bredde,$url);
		push(@punktnavn, $navn);
		$lastpartp{$navn,$menyID,$meny2,$url}=1;
	    }
	}

    } elsif ($innlinje =~ /^LINJE/) {
	# Ekstrakt ut navnet p linja og urlen
	($tmp,$navn,$url_inf)=split(/\s+/,$innlinje,3);
	($url, $meny2)=split(/[|]/, $url_inf);

  	next if ! $linjer{"$navn"} || $ikke{"$navn"};       ######
	
	if ($linje_liste{$navn}){
	    
	    if (! $lastpartl{$navn,$menyID,$meny2,$url}) {
		$linje_liste{$navn}=$linje_liste{$navn}."|$menyID $meny2,$url";
		$lastpartl{$navn,$menyID,$meny2,$url}=1;
	    }
	} else {                           
	    
	}
    }
}
    


# legger ut omrde-map for andre kart
$omsluttet=0;

if (defined($storleik{$kartet})) { # fant kartet i lista

    @sortert=sort { $storleik{$a} <=> $storleik{$b}} @kartene;
  kart: foreach $kartnavn (@sortert){
      next if $kartnavn eq $kartet;
      next unless $niv{$kartnavn} > 0;
#	next if $niv{$kartnavn} == $niv{$kartet};
      next if $niv{$kartnavn} > ($niv{$kartet} + 1);

      if (innafor($kartet, $kartnavn)) { 
	  i_rektangel($kartnavn);
      } elsif ( $sosi{$kartet} ne "blank" # skjener ikke ut topo til geo
	       && (innafor($kartnavn, $kartet) > 3)){ # omsluttet
	  om_rektangel($kartnavn);
      }
  }
}
#ok @linjer=values(%linje_liste);
#ok @punkter=values(%punkt_liste);
#ok @areas=values(%area_liste);

# skriver ut  map'ene med de korteste linjene frst slik at de blir "verst"
if ( $opt_java ){
    print ("<APPLET codebase=\"$opt_javabase\" code=\"$opt_javacode\" width=$gif_size[0] height=$gif_size[1] >\n");
## JAVA parametrene
    print ("<PARAM name=\"image\" value=\"$gif_fila\">\n");
    $teller=1;

    foreach $navn (@punktnavn){
	$punkt=$punkt_liste{$navn};
	print ("<PARAM name=\"Punkt$teller\" value=\"$punkt\" >\n");
	$teller++;
    }

    $teller=1;

    foreach $lid ( sort {$llengde{$a} <=> $llengde{$b}} keys %llengde){

#ok    print ("$lid  <=> $llengde{$lid} \n $linjer[$lid] \n");
#ok    <STDIN>;
	print ("<PARAM name=\"Linje$teller\" value=\"$linje_liste{$lnavn{$lid}}\" >\n");
	$teller++;
    }
#ok <STDIN>;

    $teller=1;
    foreach $area (@javaareas){
	print ("<PARAM name=\"omraade$teller\" value=\"$area\" >\n");
	$teller++;
    }
}

## Parametrene til browswrens standard map-funksjonalitet.
## Merk at denne delen er ogs innenfor 'APPLET tag slik at
## denne delen vil bli brukt hvis java ikke enablet
#unless ( $opt_imagemap){
    print "<img src=\"$gif_fila\" usemap=\"#$opt_kart\"></P>\n";
    print "<map name=\"$opt_kart\"> \n";
#}

foreach $navn (sort keys %x){
    @urler=split("[|]",$punkt_liste{$navn});
    ($K1,$K2,$Bredde,$navn)=split(/\s*,\s*/,$urler[0]);
    ($meny, $url)=split(/\s*,\s*/, $urler[1], 2);
    print "<area shape=\"circle\" coords=\"$K1,$K2,$Bredde\" alt=\"$navn\" href=\"$url\"> \n";

}
foreach $lid ( sort {$llengde{$a} <=> $llengde{$b}} keys %llengde){
    @urler=split("[|]",$linje_liste{$lnavn{$lid}});
    ($K1,$K2,$K3,$K4,$K5,$K6,$K7,$K8,$navn)=split(/\s*,\s*/, $urler[0]);
    ($meny, $url)=split(/,/, $urler[1], 2);
    print ("<area shape=\"polygon\" coords=\"$K1,$K2,$K3,$K4,$K5,$K6,$K7,$K8\" alt=\"$navn\" href=\"$url\"> \n");    

    if ( $aldri){ # ingen vits i  legge ut flere URL'er n
	foreach $url (@urler[1..$#urler]){
	    ($navn,$url)=split(/\s*,\s*/, $url);
	    print ("<area shape=\"polygon\" coords=\"$K1,$K2,$K3,$K4,$K5,$K6,$K7,$K8\" alt=\"$navn\" href=\"$url\"> \n");
	}
    }
}

# legg ut rektangler

foreach $rect ( sort keys %rect_name){
    @urler=split(/\|/,$punkt_liste{$rect});
    my($info, $url)= split(/,/, $urler[1]);    
    printf "<area shape=\"rect\" coords=\"%d,%d,%d,%d\" alt=\"%s (%s)\" href=\"%s\">\n",
    @{$rect_co{$rect}}, $rect_name{$rect}, $url, $url;
}

#unless ( $opt_imagemap){
    foreach $area (@areas){
	($K1,$K2,$K3,$K4,$navn,$url)=split(/\s*,\s*/,$area);
	print "<area shape=\"rect\" coords=\"$K1,$K2,$K3,$K4\" alt=\"$navn\" href=\"$url\"> \n";
    }
#}

print ("</map>\n");
print ("</APPLET>\n") if $opt_java;

unless ( $opt_imagemap){

if ($opt_last){
    print "<img src=/kart/legend-last2.gif>\n";
    print "<img src=/kart/legend-last.gif>\n";

    print "<br>Kartet viser gjennomsnittlig linjelast siste uke og kapasitet for
UNINETTs nett. Bredden p pilene viser kapasiteten, og fargen
viser hvor hy belastningen p linja var i angitt periode. 
For tidsrom dag og uke  er det travel time for den enkelte linje som er vist,
og dette er ikke ndvendigvis den samme timen for alle linjene. Kartet
tar hensyn til at linjene er full duplex, derfor er det piler som
mtes p midten. Det kan avogtil vre vanskelig  skille linjer fra
hverandre. Husk da p at de korteste linjene alltid ligger verst. ";

} else {
    print "<img src=/kart/legend-linje.gif>\n";
}



print "\nTrykk p punkter og linjer for opplysninger om disse. Trykk utenfor disse for  komme til kart med lavere eller hyere niv. Ringer rundt punkter betyr at det er linjer som er for korte til  vises p dette kartet. Rundt disse punktene vil det vre flsomme omrder slik at man komme inn til kart over de store byene og hgskolene. Flg med URL'en som vises av WWW-leseren.\n";

# legger ut url-tabell for direkteoppslag

print "<h3>Oversikt over relaterte kart</h3>
Hvert kart vises med forskjellige informasjonshold og teknikk som vist 
i tabellen.
<table border><tr><th>Kart\n";

%typenavn=("geo", "Geografisk", "topo", "Topologisk");
if ($opt_java) {
    $colspan=2;
} else {
    $colspan=4;
}

foreach $type ( "geo", "topo"){
    print "<th colspan=$colspan>$typenavn{$type}\n";
}

foreach $kart (sort { $storleik{$b} <=> $storleik{$a}} @kartene){
    next if $niv{$kart} < 1 || $niv{$kart} > ($niv{$kartet} + 1);

    if ( innafor($kartet, $kart) || innafor($kart, $kartet)){
	print "<tr><th align=left>$kart\n";

	foreach $type ( "geo", "topo"){
	    if ($type eq "geo" && $sosi{$kart} eq "blank"
		|| ($type eq "topo" && $kart =~ /-[1-9]$/)){

		print "<td><td>";
		print "<td><td>" if ! $opt_java;
	    } else {
		if ( $opt_java ) { # lag dynamiske kart-pekere
		    print "<td>";
		    print "<td><a href=/kartg/last/$net/$kart/$type>last nuh</a>\n";
		} else {
		    foreach $info ( "medlem", "ruter", "www", "trafikk" ){
			print "<td><a href=/kart/$type/$info/$kart.html>$info</a>\n";
		    }
		}
	    }
	} 
    }
}
print "</table>";
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$dato=sprintf "$year-%02d-$mday %02d:%02d:%02d", $mon, $hour, $min, $sec;
print "<hr>HTML laget $dato, Olav.Kvittem\@uninett.no\n";
print "</BODY> </HTML>\n";

}
close (URLS);


print STDERR "antall linjer: $#linjer\nantall steder : $#steder \n" if $opt_v;

exit( 0);

#------------------------------------------------------------------------
# legger ut en area map for et kart-rektangel 

sub i_rektangel {
    my ($k) = pop(@_);

    $ekstra = $ekstra_map;
    if ($niv{$k} > 0){
	$ekstra *= 2 / $niv{$k}; 
    }
    $x1=ost2gif($o1{$k}) ; $y1=nord2gif($n2{$k}) ;
    $x2=ost2gif($o2{$k}) ; $y2=nord2gif($n1{$k}) ;

    if ( ($x2 - $x1 ) <  (2*$ekstra)){
	$x1 -= $ekstra, $x2 += $ekstra if abs($x2 - $x1) < 2*$ekstra;
    }
    if ( ($y2 - $y1 ) <  (2*$ekstra)){
	$y1 -= $ekstra, $y2 += $ekstra if abs($y2 - $y1) < 2*$ekstra;
    }

    $area = sprintf ("%d,%d,%d,%d,$k,$href{$k}",$x1, $y1, $x2, $y2);
    if ( $opt_java){
	push(@javaareas, $area . areameny($k));
    }
    push(@areas, $area); # html areas
    $ekstra=0;
}


sub om_rektangel {
    my ($k) = pop(@_);

    #printf "<area shape=rect alt=$k coords=%d,%d,%d,%d href=$href{$k}>\n",0, 0, $gif_size[0]-1, $gif_size[1]-1;

    $area = sprintf ("%d,%d,%d,%d,$k,$href{$k}",0,0,$gif_size[0]-1, $gif_size[1]-1);
    if ( $opt_java){
	push(@javaareas, $area . areameny($k));
    }
    push(@areas, $area); # html areas

    $ekstra=0;
}

sub areameny {

    return if ! $opt_areameny;

    my ($k) = pop(@_);
    my($areameny);

    if ( $sosi{$k} eq "blank" ){
	@typer=("topo");
    } elsif ( $k =~ /-[1-9]$/){ # knutekart
	@typer=("geo");
    } else {
	@typer= ("geo", "topo");
    }
    for $type ( @typer){
	for $slag ( "linje", "last"){
	    $areameny.="|$type-$slag,/kart/$type/$slag/$k.html";
	}
    }
    return($areameny);
}

# lage side-url-liste for java-html
sub sideurler {
    my ($k) = pop(@_);
    my($urler);
    if ($opt_href){
	$urler.="\n<br>$opt_href";
    } else {
	if ( $sosi{$k} eq "blank" ){
	    @typer=("topo");
	} elsif ( $k =~ /-[1-9]$/){ # knutekart
	    @typer=("geo");
	} else {
	    @typer= ("geo", "topo");
	}
	for $type ( @typer){
	    for $slag ( "linje", "last"){
		next if $opt_gif =~ "$type/$slag"; 
		$urler.=", <a href=/kart/$net/$type/$slag/$k.html>$type-$slag</a>";
	    }
	}
    }
    return($urler);
}

# sjekker om kart $in er innafor $om
# returnerer antall hjrner innafor

sub innafor{
    my($om, $in) = @_;
    my($n)=0;
    $n++ if punktinne( $n1{$in}, $o1{$in}, $om );
    $n++ if punktinne( $n2{$in}, $o2{$in}, $om );
    $n++ if punktinne( $n2{$in}, $o1{$in}, $om );
    $n++ if punktinne( $n1{$in}, $o2{$in}, $om );
    return ($n);
}

sub punktinne{
    my($n,$o, $om)=@_;
    return $n >= $n1{$om} && $n <= $n2{$om} &&
            $o >= $o1{$om} && $o <= $o2{$om};
}

sub nord2gif {
    my($nord)=pop(@_);
    return ($gif_size[1]-(($nord - $grunn_koords[0]) / $skalering * $giftrans));
}

sub ost2gif {
    my($ost)=pop(@_);
    return (($ost - $grunn_koords[1]) / $skalering * $giftrans);
}








