#! /local/bin/perl
# opsjon -d virker ikke m justeres etter endring i varible osb.

use POSIX;

push(@INC,"/home/drs/oak/kart/lib/perl");
require "kart-lib.pl";
require "newgetopt.pl";
require "utm.pl";

$;="#";
$sone=33;
$minstemaal=40; # faktor for kort linje
$minx=$miny=99999999;
$maxx=$maxy=-99999999;
$nkastl=$nkastp=$ndupkast=0;
$grunn_kart="$kartsystemdir/lib/conf/alt.omriss";
$hoved_kart="$kartsystemdir/lib/conf/kart.omriss";
$omrade_sone=33;
$min_kant= 1000; # minste kant_bredde 

$usage="Tynner ut de linjene som er kortere enn 1/$minstemaal 
av linja mellom ekstremkoordinatene. 
Kaster bare kardinalitet 1 punkter og linjer til slike.
Tall i parentes angir antall linjer til punktet - kardinalitet.

  kartluk [-v] [-d] [-minste <faktor>] [-omrade <n1,1,n22>] <koordinatfil>
    -d - kast dublerte punkter
    -v - skriv meldinger til STDERR
    -minste - faktor for minste linje ($minstemaal)
    -omriss <fil> ($hoved_kart)
    -omrade - fjern koordinater utenfor omrdet - navn eller koordinater
              (sone, nedre venstre nord, .. , vre hyre st)
    -knuter <fil>  - lag omriss for sammensltte omrder
    -niv <nr> - zoom-niv for dette kartet til knuter-filer
    -rand <%> - rand i% utenfor genererte omriss (normalt gjort i kartgrunnlag)
";
die $usage if !&NGetOpt('minste=s', 'omrade=s', 'sone=s', 'knuter=s', 'niv=s', 'omriss=s', 'rand=n', 'v', 'd');

$minstemaal = $opt_minste || $minstemaal;
$opt_minste = $minstemaal if ! ( $opt_minste || $opt_omrade);
$sone = $opt_sone if $opt_sone;
$ramme= $opt_omriss || $hoved_kart;


# less inn kartoversikt for  finne beste kartgrunnlag for knutepunkter

if ($opt_omrade){
    if ( $opt_omrade =~ /[a-z]/) { # anta navn fra config
	open( RAMME, "$ramme") 
	    || die "Fikk ikke pnet $ramme";
	while(<RAMME>){
	    next if /^#/;
	    if(/$opt_omrade/){
		($ps, $kart, $velg, $layout, $omrade_sone, 
		 $nvy, $nvx, $ohy, $ohx, $stor, $ramme_niv) =split(",");
		last;
	    }
	}
	close RAMME;
	die "Fant ikke $opt_omrade i $ramme\n$usage" if ! defined($ps);
    } else {
	($omrade_sone,$nvy, $nvx, $ohy, $ohx)=split(",", $opt_omrade) ;
	die "Feil format p $opt_omrade i $ramme\n$usage" if ! defined($ohx);
    }
}
$niv = $opt_niv || $ramme_niv;
$nniv = $niv + 1;

# less inn koordinatfila og gjr innledende datastrukturoppbygging

$lid=$pid=0;

while(<>){
    ($type, $tema, $rest) = split("[ \t]+", $_, 3);
    chop($rest);

    if($type =~ /linje/i) {
	push(@linjer, $_);
        $linfo[$nlin]=$rest;
	$nlin++;

    } elsif($type =~ /punkt/i) {
	$npunkt++;
	($pnavn, $sone1, $y1, $x1, $resten) = split("[ \t]+", $rest);

	if ($opt_omrade) {
	    if (utenfor( $sone1, $y1, $x1)){
		$utenfor{$pnavn}=1;
		$npunktut++;
		next;
	    }
        }

	$p1="$sone1,$y1,$x1";
	$koord{$pnavn}=$p1;
	$kast{$pnavn}=0;
	$kastet{$pnavn}=0;
	$pnavn[$pid]=$pnavn;

	if ( defined($punkt{$p1})){
	    $dupl{$pids{$p1}}=$pid;
	    $ndupl++;
	    printf STDERR "Duplikat: $pnavn{$p1} : $_" if $opt_v && $opt_d;
	} 

	$pids{$p1}=$pid;
	$punkt{$p1}=$pnavn;

	($y1, $x1)=&utmtoutm($y1,$x1,$sone1,$omrade_sone);
	$maxx = $x1 if $x1 > $maxx;
	$minx = $x1 if $x1 < $minx;
	$maxy = $y1 if $y1 > $maxy;
	$miny = $y1 if $y1 < $miny;

	push(@punkter, $_);
	$pid++;

    } else {
	push(@resten, $_);
    }

}

# rydd bort linjer og punkter som er utenfor

if ($opt_omrade) {

    foreach $lid (0 .. $#linjer) {
	($lnavn, $pn1, $pn2, $resten) = split(/[ \t]+/, $linfo[$lid]);
	if ($utenfor{$pn1} || $utenfor{$pn2}){
	    $kastlin{$lid}++;
	    $nlineut++;
	}
    }
}

if ($opt_minste) {
    $diagonal = POSIX::sqrt( ($maxx - $minx)**2 + ($maxy - $miny)**2);
    $minste = $diagonal/$minstemaal;

# masser linjer og finn lengder og kardinalitet

    foreach $lid (0 .. $#linjer) {
	($lnavn, $pn1, $pn2, $resten) = split(/[ \t]+/, $linfo[$lid]);
	
	($sone1, $y1, $x1)  = split(",", $koord{$pn1});
	($sone2, $y2, $x2)  = split(",", $koord{$pn2});

	$lno{$pn1}++;
	$lno{$pn2}++;
	$naboer{$pn1}.="$pn2,";
	$naboer{$pn2}.="$pn1,";

	($y1, $x1)=&utmtoutm($y1,$x1,$sone1,$omrade_sone) 
	    if ($sone1 != $omrade_sone) ;
	($y2, $x2)=&utmtoutm($y2,$x2,$sone2,$omrade_sone) 
	    if ($sone2 != $omrade_sone) ;
	$length{$lid} = POSIX::sqrt(($x2-$x1)**2+ ($y2-$y1)**2);
        $llength{$pn1}+=$length{$lid};
        $llength{$pn2}+=$length{$lid};

    }

# finn avstand fra punkt med flest linjer

    foreach $p (keys %lno){
	$maxlno=$lno{$p}, $maxp=$p if $maxlno < $lno{$p};
    }
    
    tell_neste($maxp, 1);
    
    sub tell_neste {
	my($dette, $hopp)= @_;
	if( $hopp{$dette} > 0){
	    return if $hopp  >= $hopp{$dette};
	} 
	$hopp{$dette}= $hopp ;

	foreach $nabo (split(",", $naboer{$dette})){
	    tell_neste($nabo, $hopp +1);
	}
    }

# merk linjer som skal kastes

foreach $lid (0 .. $#linjer) {
    ($lnavn, $pn1, $pn2, $resten) = split(/[ \t]+/, $linfo[$lid]);
    
    if ($length{$lid} < $minste && ! $kastlin{$lid}) { # helst kastes

	($ha, $ta) = fittest($pn1, $pn2);
	next if !$ha;

	if ($lno{$ta} > 1){  # andre linjer tegnes til naboen
	    if ( $erstatt{$ta} ){
		($nyha, $tmp) = fittest($erstatt{$ta}, $ha);
		$erstatt{$ta}=$nyha if $nyha;
	    } else {
		$erstatt{$ta} = $ha;
	    }
	} else {
	    $erstatt{$ta} = $ha;
	}
	$kast{$ta} = 1;
	$nabokast{$ha} ++;
	$lno{$ha}--;

	printf STDERR "Kast: (%2d,%2d)%-20s-(%2d,%2d)%-20s %.1fkm \n", 
	$hopp{$ha},$lno{$ha},$ha,$hopp{$ta},$lno{$ta},$ta, 
	$length{$lid}/1000
	    if $opt_v;
	$kastlin{$lid}=1;
	$nkastl++;
    }
}
}


# skriv ut linjer som ikke skal kastes

for $lid ( 0 .. $#linjer) {
    if (! $kastlin{$lid}){
	($lnavn, $pn1, $pn2, $resten) = split(/[ \t]+/, $linfo[$lid]);
	$linje = $linjer[$lid];

	if($ny=$erstatt{$pn1}){ # finn evt erstatingspunkt
	    while($erstatt{$ny}){
		$ny=$erstatt{$ny};
	    }
	    $linje =~ s/ $pn1 / $ny /;
	}

	if($ny=$erstatt{$pn2}){
	    while($erstatt{$ny}){
		$ny=$erstatt{$ny};
	    }
	    $linje =~ s/ $pn2 / $ny /;
	}
	print $linje;
    }
}


# skriver ut punkter som ikke skal kastes

foreach $pid (0 .. $#punkter) {
    $pnavn=$pnavn[$pid];

if (! ($kast{$pnavn} || $kastet{$pnavn})){ 
    if ( $opt_minste && $lno{$pnavn} < 1){
	printf STDERR "Linjelst: $punkter[$pid]" if $opt_v;
	next;
    } 

    if($opt_d && $dupl{$pid}) { # kaster punkter med lavest kardinalitet
	my($npid)=$pid;
	while( $npid=$dupl{$npid}){
	    if ($lno{$pnavn} < $lno{$pnavn{$npid}}){
		$kast{$pnavn} ++;
	    } else {
		$kast{$pnavn{$npid}} ++;
	    }
	}

	&utp($pid) if ! $kast{$pnavn};
	$nkastdup++ if $kast{$pnavn};
    } else {

	&utp($pid);
    }
} else {
#	print STDERR "Kast:", $punkter[$pid] if $opt_v;
    $nkastp++;
    $kastet{$pnavn}=1;

    if($ny=$erstatt{$pnavn}){
	while($erstatt{$ny}){
	    $ny=$erstatt{$ny};
	}
	$erstatter{$ny} .= "$pnavn,";
    }
}
}


# lager omriss for knuter og deres skjulte punkter

if ( $opt_knuter && defined(%erstatter)){
    less_omriss();

    open (OMRISS, ">$opt_knuter") || die "Fikk ikke pnet $opt_knuter";

foreach $knute (keys %erstatter){
    my($svn, $svo, $non, $noo) = omriss($knute, split(",", $erstatter{$knute}));
    if ($opt_rand){
	$k= $opt_rand/100;
	$dn= abs($non-$svn) * $k;
	$do= abs($noo-$svo) / $k;
#    $dn= $min_kant if $dn < $min_kant;
#    $do= $min_kant if $do < $min_kant;
	if ( $dn < $min_kant && $do < $min_kant){
	    $dn = $do = $min_kant;
	} elsif ( $dn < $min_kant ){
	    $dn = $do;
	}elsif ( $do < $min_kant ){
	    $do = $dn;
	}
	$svn -= $dn; $non += $dn;
	$svo -= $do; $noo += $do;
    }

    $modell=beste_kart($svn,$svo,$non,$noo);

    printf OMRISS "$knute-$nniv.ps,$sosi{$modell},$velg{$modell}-$nniv,$layout{$modell}-$nniv,$omrade_sone,%d,%d,%d,%d,500x664,%d,Knute $knute-$nniv\n",
    $svn,$svo,$non,$noo,$nniv;
}
close OMRISS;
}


print @resten;

if ($opt_v){
    printf STDERR "Det var %d linjer og %d punkter.\n", $nlin, $npunkt;
printf STDERR "Kastet %d linjer og %d punkter der minste linje er : %.1fkm av %.1fkm(/$minstemaal).\n",  
    $nkastl, $nkastp, $minste/1000,  $diagonal/1000 if $opt_minste;
printf STDERR "Det var %d dublerte punkter og %d ble kastet\n", 
    $ndupl, $nkastdup if $ndupl;
printf STDERR "Det var %d linjer og %d punkter utenfor $opt_omrade\n",
    $nlineut, $npunktut if $opt_omrade;
printf STDERR "og det var %d linjer og %d punkter innenfor \n",
    $nlin - $nlineut, $npunkt - $npunktut if $opt_omrade;
}

exit(0); # slutt p programmet

#------------------------------------------------------------------------    

sub utp {
    my($pid)=pop;
    my($pnavn)=$pnavn[$pid]; #pid
    $_= $punkter[$pid];

    if( $nabokast{$pnavn}){
	s/ sted / stedsky /;
    }
    print ;
}

sub utenfor {
    my($sone, $y, $x)=@_;
    ($y, $x) = utmtoutm($y, $x, $sone, $omrade_sone) 
	if $sone != $omrade_sone;
    return($y < $nvy || $y > $ohy || $x < $nvx || $x > $ohx || 0 );
}


sub fittest {
    my($ha, $ta);

    if ($hopp{$pn1} < $hopp{$pn2}){
	$ha=$pn1;
	$ta=$pn2; 
    } elsif ($hopp{$pn1} > $hopp{$pn2}){
	$ha=$pn2;
	$ta=$pn1;
    } elsif ( $lno{$pn1} > $lno{$pn2}){
	$ha=$pn1;
	$ta=$pn2;
    } elsif ( $lno{$pn1} < $lno{$pn2}){
	$ha=$pn2;
	$ta=$pn1;
    } elsif ( $llength{$pn1} > $llength{$pn2}){
	$ha=$pn1;
	$ta=$pn2;
    } elsif ( $llength{$pn1} < $llength{$pn2}){
	$ha=$pn2;
	$ta=$pn1;
    } else { # gi opp og behold
        # $ha=$pn2;
	# $ta=$pn1;
    }
    return ($ha, $ta);
    
}


# finn omriss for en list punkter

sub omriss {
    my( $maxy, $maxx, $miny, $minx)=(0, -9999999, 99999999, 9999999);
    foreach $p (@_){
    	my ($sone1,$y1,$x1) = split(",", $koord{$p});

	($y1, $x1)=&utmtoutm($y1,$x1,$sone1,$omrade_sone) 
	    if $sone1 != $omrade_sone;
	$maxx = $x1 if $x1 > $maxx;
	$minx = $x1 if $x1 < $minx;
	$maxy = $y1 if $y1 > $maxy;
	$miny = $y1 if $y1 < $miny;
    }
    return ( int($miny), int($minx), int($maxy), int($maxx)); # syd-vest, nord-st

}



# finn det beste kartet  tegne p ved  
# lesse inn kartliste og ta det minste som omslutter.


sub less_omriss {

    open(LISTE, $grunn_kart) || die "Fant ikke $hoved_kart\n";

    while(<LISTE>){

	next if /^#/;
	my($kartnavn, $sosi, $velg, $layout, $sone, $n1, $o1, $n2, $o2, 
	   $stor, $niv, $rest) =split(/\s*\,\s*/);
	$kartnavn =~ s/.ps$//;

	if ($sone != $omrade_sone){
	    ($n1, $o1) = utmtoutm($n1, $o1, $sone, $omrade_sone);
	    ($n2, $o2) = utmtoutm($n2, $o2, $sone, $omrade_sone);
	}

	push(@kartene, $kartnavn);
	$storleik{$kartnavn}= abs($n2 - $n1) * abs($o2 - $o1);
	$sosi{$kartnavn}=$sosi;
	$n1{$kartnavn}=$n1;
	$n2{$kartnavn}=$n2;
	$o1{$kartnavn}=$o1;
	$o2{$kartnavn}=$o2;
	$niv{$kartnavn}=$niv;
	$velg{$kartnavn}=$velg;
	$layout{$kartnavn}=$layout;


    }
    close LISTE;
    @sortert=sort { $storleik{$a} <=> $storleik{$b}} @kartene;
}

sub beste_kart {
    my($svn,$svo,$non,$noo)=@_;
    foreach $om (@sortert){
      if ($svn >= $n1{$om} && $non <= $n2{$om} &&
	  $svo >= $o1{$om} && $noo <= $o2{$om}){
	  return($om);
      }
  }
}
