#!/local/bin/perl
# lager postscriptkode for  tenge linjer og punkter p
# et grunnlagskart i postscript

push(@INC,"/home/drs/oak/kart/lib/perl");
require "kart-lib.pl";
require "newgetopt.pl";
require "utm.pl";

$usage="Transformerer linjer og punkter til postscript-kode, 
egnet for  legges til grunnlagskart. Bruk:

  karttegn [-ekstern] [-kart <fil>] -konf <fil> <koordinatfil>
    -ekstern  - tegn p linjer som gr ut av kartet
";
die $usage if !&NGetOpt('kart=s', 'konf=s', 'ekstern');
$default_map = "$kartdir/grunnlag/norge.ps";
$default_konf = "$kartlibdir/conf/karttegn.konf";
open(DEBUG, ">/home/domen/b/vegard/kart/tmp/debug");
open(DEBUG2, ">/home/domen/b/vegard/kart/tmp/debug2");

# Les konf;
$opt_map = $opt_kart || $default_map;
$opt_konf = $opt_konf || $default_konf;
$skalering=200; # default-verdi

# leser konfigurasjonsfil og lagrer i interne strukturer

die "Feil: Ingen konfigurasjonsfil: $opt_konf\n$usage" if(!open(KONF, $opt_konf));
while($_=<KONF>) {
    while($_ !~ /--/) {
	($kode, $arg) = split(": ", $_, 2);
	chop($arg);

	if($kode =~ /PROLOG/) {
	    while(($_=<KONF>) && ($_ !~ /--/)) {
		if (/\305|\306|\330|\345|\346|\370/) {
		    s/\305/\\305/g;
		    s/\306/\\306/g;
		    s/\330/\\330/g;
		    s/\345/\\345/g;
		    s/\346/\\346/g;
		    s/\370/\\370/g;
		}
		$prolog .= $_;
	    }
	}

	if($kode =~ /EPILOG/) {
	    while(($_=<KONF>) && ($_ !~ /--/)) {
		if (/\305|\306|\330|\345|\346|\370/) {
		    s/\305/\\305/g;
		    s/\306/\\306/g;
		    s/\330/\\330/g;
		    s/\345/\\345/g;
		    s/\346/\\346/g;
		    s/\370/\\370/g;
		}
		$epilog .= $_;
	    }
	}

	if($kode =~ /^\wTEMA/) {
	    $in_tema = "l" if($kode eq "LTEMA");
	    $in_tema = "p" if($kode eq "PTEMA");
	    $in_tema = "f" if($kode eq "FTEMA");
	    $tema = $arg;
	    if($in_tema eq "l") {
		$lineth{$tema} = 1;
		$color{$tema} = "0 0 0";
		$dash{$tema} = "1 0";
		$type{$tema} = "L";
	    }
	    if($in_tema eq "p") {
		$type{$tema} = "P";
		$code{$tema} = "";
		$color{$tema} = "0 0 0";
	    } 
	    if($in_tema eq "f") {
		$lineth{$tema} = 1;
		$color{$tema} = "0 0 0";
		$dash{$tema} = "1 0";
		$type{$tema} = "L";
	    }
	}

	if($in_tema eq "l") {
	    $lineth{$tema} = $arg if ($kode eq "LINETH");
	    $color{$tema} = $arg if ($kode eq "COLOR");
	    $type{$tema} = $arg if ($kode eq "TYPE");
	    $dash{$tema} = $arg if ($kode eq "DASH");
	    $desc{$tema} = $arg if ($kode eq "DESCRIPTION");
	    $border{$tema} = $arg if ($kode eq "BORDER");
	    $comment{$tema} = $arg if ($kode eq "COMMENT");

	    if($kode =~ /CODE/) {
		$code{$tema} = "";
		while(($_=<KONF>) && ($_ !~ /--/)) {
		    $code{$tema} .= $_;
		}
	    }

	} elsif($in_tema eq "p") {
	    $desc{$tema} = $arg if ($kode eq "DESCRIPTION");
	    $type{$tema} = $arg if ($kode eq "TYPE");
	    $color{$tema} = $arg if ($kode eq "COLOR"); 
	    if($kode =~ /CODE/) {
		while(($_=<KONF>) && ($_ !~ /--/)) {
		    if (/\305|\306|\330|\345|\346|\370/) {
			s/\305/\\305/g;
			s/\306/\\306/g;
			s/\330/\\330/g;
			s/\345/\\345/g;
			s/\346/\\346/g;
			s/\370/\\370/g;
		    }
		    $code{$tema} .= $_;
		}
	    }
	    $comment{$tema} = $arg if ($kode eq "COMMENT");
	}
	if(!($_ = <KONF>)) {
	    last;
	}
	if (/\305|\306|\330|\345|\346|\370/) {
	    s/\305/\\305/g;
	    s/\306/\\306/g;
	    s/\330/\\330/g;
	    s/\345/\\345/g;
	    s/\346/\\346/g;
	    s/\370/\\370/g;
	}
    }
}
close(KONF);


# leser inn grunnlagskart for  finne strrelse

die "Finner ikke grunnlagskartet: $opt_map\n$usage" if(!open(MAP, $opt_map));
while(($_ = <MAP>) && ($_ !~ /^\%EndHeader/)) {

    if (/%Skalering:/){
	($junk, $skalering) = split;
    } elsif($_ =~ /%Area:/) {
	($junk, $ymin, $xmin, $ymax, $xmax) = split(/[,\s]/);
	$xmin /= $skalering;
	$ymin /= $skalering;
	$xtrans = -$xmin;
	$ytrans = -$ymin;
	$xmax /= $skalering;
	$ymax /= $skalering;
#    $xwid=$xmax-$xmin;
#    $ywid=$ymax-$ymin;
#    $xsc=600/$xwid;
#    $ysc=800/$ywid;
#    if($xsc>$ysc) {
#       $sc = $ysc;
#    } else {
#       $sc = $xsc;
#    }
	next;
    } elsif($_ =~ /%Sone:/) {
	($junk, $sone) = split;
    }
    
}
close(MAP);


#------------------------------------------------------------------------
# starter utskrift av kartet og leser koordinat-filer
# frste pass samler koordinater for punkter

print "$prolog\n";

while($_=<>) {
chop($_);
# gjr tranparent 
    if (/\305|\306|\330|\345|\346|\370/) {
	s/\305/\\305/g;
	s/\306/\\306/g;
	s/\330/\\330/g;
	s/\345/\\345/g;
	s/\346/\\346/g;
	s/\370/\\370/g;
    }
    ($type, $tema, $rest) = split(" ", $_, 3);

    if($type =~ /linje/i) {
	push(@linjer, $_);

    } elsif($type =~ /punkt/i) {
	push(@punkter, $_);
	($pnavn, $sone1, $y1, $x1, $resten) = split("[ \t]+", $rest);
	$p1="$sone1,$y1,$x1";
	$koord{$pnavn}=$p1;
    }
}

# pass 1b regner avstander
$lid=0;

foreach (@linjer){
    ($type, $tema, $rest) = split(" ", $_, 3);

    ($lnavn, $pn1, $pn2, $resten) = split(/[ \t]+/, $rest, 4);
    ($sone1, $y1, $x1)  = split(",", $koord{$pn1});
    ($sone2, $y2, $x2)  = split(",", $koord{$pn2});
    
    ($y1,$x1)=&utmtoutm($y1,$x1,$sone1,$sone) if ($sone1 != $sone);
    ($y2,$x2)=&utmtoutm($y2,$x2,$sone2,$sone) if ($sone2 != $sone);
    
    $lengde{$lid}= sqrt(abs($y2-$y1)**2+abs($x2-$x1)**2);
    $lid++;
}

# pass 2 tegner

foreach $lid ( sort{ $lengde{$b} <=> $lengde{$a}} keys %lengde){
    ($type, $tema, $rest) = split("[ \t]+", $linjer[$lid], 3);
    ($lnavn, $pn1, $pn2, $resten) = split(/[ \t]+/, $rest, 4);
	($sone1, $y1, $x1)  = split(",", $koord{$pn1});
	($sone2, $y2, $x2)  = split(",", $koord{$pn2});
    print STDERR "$type, $tema, $rest, $pn1, $pn2, $koord{$pn1}, $koord{$pn2}\n";

	($y1,$x1)=&utmtoutm($y1,$x1,$sone1,$sone) if ($sone1 != $sone);
	($y2,$x2)=&utmtoutm($y2,$x2,$sone2,$sone) if ($sone2 != $sone);

    
	$xout=   (($x1/$skalering) < $xmin) || (($x1/$skalering) > $xmax) ||
		(($y1/$skalering) < $ymin) || (($y1/$skalering) > $ymax) ;
	$yout=	(($x2/$skalering) < $xmin) || (($x2/$skalering) > $xmax) ||
		(($y2/$skalering) < $ymin) || (($y2/$skalering) > $ymax);

    if ($opt_ekstern){
	next if $xout && $yout;
    } else {
	next if $xout || $yout;
    }


	print "% $desc{$tema}\n" if $desc{$tema};
	print "$color{$tema} setrgbcolor\n" if $color{$tema};
	if($dash{$tema}) {
	    ($b, $w) = split(" ", $dash{$tema});
	    print "[$b sc div $w sc div] 0 setdash\n";
	}
	print "$lineth{$tema} sc div setlinewidth\n" if $lineth{$tema};
	print "% Comment: $comment{$tema}\n" if $comment{$tema};
	if($type{$tema} eq "C") {
	    # lar postscript-koden gjre skalering pga fleksibilitet
	    print "$x1 $y1 $x2 $y2 $resten $code{$tema}\n";
	} else {
	    $x1 /=$skalering;
	    $y1 /=$skalering;
	    $x2 /=$skalering;
	    $y2 /=$skalering;
	    print "$x1 $y1 moveto $x2 $y2 lineto stroke\n";
	}
}

foreach (@punkter){
    ($type, $tema, $rest) = split("[ \t]+", $_, 3);
	($pnavn, $sone1, $y1, $x1, $resten) = split(" ", $rest);

	($y1, $x1)=&utmtoutm($y1,$x1,$sone1,$sone) if ($sone1 != $sone);

	next if((($x1/$skalering) < $xmin) || (($x1/$skalering) > $xmax) ||
		(($y1/$skalering) < $ymin) || (($y1/$skalering) > $ymax));

	print "% $desc{$tema}\n" if $desc{$tema};
	print "$color{$tema} setrgbcolor\n" if $color{$tema};
	print "$lineth{$tema} sc div setlinewidth\n" if $lineth{$tema};
	print "% Comment: $comment{$tema}\n" if $comment{$tema};

	if($type{$tema} eq "C") {
	    # lar postscript-koden gjre skalering pga fleksibilitet

	    print "$x1 $y1 $resten $code{$tema}\n";
	} else {
	    $x1 /=$skalering;
	    $y1 /=$skalering;
	    print "$x1 $y1 moveto $code{$tema}\n";
	}
}


print "$epilog\n";

