package utmgeo;
$a = 6378137;
$f=1/298.257223563;
$e2=$f*(2-$f);
$e2m = $e2/(1-$e2);
$n=$f/(2-$f);


sub main'utmtogeo {
  local($X,$Y, $sone)=@_;
  local($psi, $Wpsi, $Vpsi, $N, $my, $THETApsi, $Spsi, $rho, $ny, $phim,
        $dlambda, $dpsi, $phi, $lambda,$lambda0);
  $psi=$X/(0.9996 * 6366197.724);
  $Vpsi=sqrt(1+$e2m*(cos($psi)**2));
  $Wpsi=sqrt(1.0-$e2*sin($psi)*sin($psi));
  $N=$a/$Wpsi;
  $my=($Y-500000)/(0.9996*$N);
  $THETApsi=$psi-((3/2)*$n-(31/24)*($n**3)-((15/8)*($n**2)-(435/128)*
  ($n**4))*cos(2*$psi)+(35/2)*($n**3)*(cos(2*$psi)**2)-(315/64)*($n**4)*(cos($psi*2)**3))*sin(2*$psi);
  $Spsi=($a/(1+$n))*(1+(1/4)*($n**2)+(1/64)*($n**4))*$THETApsi;
  $rho=($X/0.9996-$Spsi)/$N;
  $ny=$my*(1-($e2m/6)*(cos($psi)**2)*($my**2));
  $phim=$psi+$rho*(1-($e2m/2)*(cos($psi)**2)*($my**2));
  $dlambda=atan2(0.5*(exp($ny)-exp(-$ny))/cos($phim), 1);
  $dpsi=atan2(cos($dlambda)*sin($phim)/cos($phim), 1)-$psi;
  $phi=$psi+($Vpsi**2)*$dpsi-(3/2)*$e2m*sin($psi)*cos($psi)*($dpsi**2);
  $lambda0=(3+($sone-31)*6)*3.14159/180;
  $lambda=$dlambda+$lambda0;
  return($phi,$lambda);
}

sub main'geotoutm {
  local($phi, $lambda, $sone) =@_;
  local($dlambda, $lambda0, $ny, $ksi, $Wphi, $N, $dgamma, $THETAphi, $Sphi, $dX, $X, $Y);
  $lambda0=(3+($sone-31)*6)*3.14159/180;
  $dlambda = $lambda - $lambda0;
  $mid=cos($phi)*sin($dlambda);
  $ny = (1/2)*log((1+$mid)/(1-$mid));
  $ksi = atan2(((sin($phi)/cos($phi))/cos($dlambda)),1)-$phi;
  $Wphi = sqrt(1-$e2*sin($phi)**2);
  $N = $a/$Wphi;
  $dgamma = $N*$ny*(1+(($e2m/6)*(cos($phi)**2)*($ny**2)));
  $dX=$N*$ksi*(1+($e2m/2*(cos($phi)**2)*$ny**2));
  $THETAphi=$phi-((3/2)*$n-(31/24)*($n**3)-((15/8)*($n**2)-(435/128)*
  ($n**4))*cos(2*$phi)+(35/2)*($n**3)*(cos(2*$phi)**2)-(315/64)*($n**4)*(cos($phi*2)**3))*sin(2*$phi);
  $Sphi=($a/(1+$n))*(1+(1/4)*($n**2)+(1/64)*($n**4))*$THETAphi;
  $X=0.9996*($dX+$Sphi);
  $Y=0.9996*$dgamma+500000;
  return($X, $Y);
}
sub main'utmtoutm {
  local($phi, $lambda, $Xn, $Yn);
  local($X,$Y, $IS, $US) = @_;
  ($phi,$lambda) = &main'utmtogeo($X,$Y,$IS);
  ($Xn, $Yn) = &main'geotoutm($phi, $lambda, $US);
  return($Xn,$Yn);
}
  
package main;

